import { OrderRule } from './_purryOrderRules';
import type { IterableContainer, NonEmptyArray } from './_types';
export declare function sortBy<T>(...rules: Readonly<NonEmptyArray<OrderRule<T>>>): (data: ReadonlyArray<T>) => Array<T>;
export declare function sortBy<T>(array: ReadonlyArray<T>, ...sortRules: Readonly<NonEmptyArray<OrderRule<T>>>): Array<T>;
interface Strict {
    <T extends IterableContainer>(...sortRules: Readonly<NonEmptyArray<OrderRule<T[number]>>>): (array: T) => SortedBy<T>;
    <T extends IterableContainer>(array: T, ...sortRules: Readonly<NonEmptyArray<OrderRule<T[number]>>>): SortedBy<T>;
}
type SortedBy<T extends IterableContainer> = {
    -readonly [P in keyof T]: T[number];
};
export declare namespace sortBy {
    const strict: Strict;
}
export {};
//# sourceMappingURL=sortBy.d.ts.map