import type { CompareFunction } from './_types';
declare const COMPARATORS: {
    readonly asc: <T>(x: T, y: T) => boolean;
    readonly desc: <T_1>(x: T_1, y: T_1) => boolean;
};
export type OrderRule<T> = Projection<T> | readonly [projection: Projection<T>, direction: keyof typeof COMPARATORS];
type Projection<T> = (x: T) => Comparable;
type Comparable = ComparablePrimitive | {
    [Symbol.toPrimitive](hint: string): ComparablePrimitive;
} | {
    valueOf(): ComparablePrimitive;
} | {
    toString(): string;
};
type ComparablePrimitive = number | string | boolean;
export declare function purryOrderRules<T>(func: (data: ReadonlyArray<T>, compareFn: CompareFunction<T>) => unknown, inputArgs: IArguments | ReadonlyArray<unknown>): unknown;
export declare function purryOrderRulesWithArgument(func: <T>(data: ReadonlyArray<T>, compareFn: CompareFunction<T>, arg: any) => unknown, inputArgs: IArguments): unknown;
export {};
//# sourceMappingURL=_purryOrderRules.d.ts.map